# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:   
  - sonarcloud-check       # List of stages for jobs, and their order of execution
  - cypress-build-job
  - functional-test-job
  

variables:
  DOCKER_IMAGE_NAME: $DOCKER_USERNAME/$CI_PROJECT_NAME
  DOCKER_IMAGE_TAG: $CI_COMMIT_SHA
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task


sonarcloud-check:
  stage: sonarcloud-check
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  script:
    - mkdir -p /builds/ss-tech1/secret-santa-application/alpha-qa/.sonar/cache
    - chmod -R 777 /builds/ss-tech1/secret-santa-application/alpha-qa/.sonar/cache
    - sonar-scanner
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"'
    
    
cypress-build-job:
  tags: 
    - akashgun-linux       # This job runs in the build stage, which runs first.
  stage: cypress-build-job
  script:
    - echo "$DOCKER_PASSWORD" | docker login -u "$DOCKER_USERNAME" --password-stdin
    - docker build -t secretsantatest .
    - docker image tag secretsantatest  akashgun/secretsantatest:latest
    - docker push akashgun/secretsantatest:latest

functional-test-job: 
  tags: 
    - akashgun-linux  # This job runs in the test stage.
  stage: functional-test-job    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "$DOCKER_PASSWORD" | docker login -u "$DOCKER_USERNAME" --password-stdin
    - docker pull akashgun/secretsantatest:latest
    - docker container rm -f akashgun/secretsantatest:latest
    - docker run akashgun/secretsantatest:latest


